Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| MID Profile
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class System

    java.lang.Object
      |
      +--java.lang.System

public final class System
extends Object

The `System` class contains several useful class fields and methods. It cannot be instantiated.

Since:
  JDK1.0

Field Summary
`static PrintStream` | `err` The "standard" error output stream.
`static PrintStream` | `out` The "standard" output stream.

Method Summary
`static void` | `arraycopy(Object src, int src_position, Object dst, int dst_position, int length)` Copies an array from the specified source array, beginning at the specified position, to the specified position of the destination array.
`static long` | `currentTimeMillis()` Returns the current time in milliseconds.
`static void` | `exit(int status)` Terminates the currently running Java application.
`static void` | `gc()` Runs the garbage collector.
`static String` | `getProperty(String key)` Gets the system property indicated by the specified key.
`static int` | `identityHashCode(Object x)` Returns the same hashcode for the given object as would be returned by the default method hashCode(), whether or not the given object's class overrides hashCode().

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### out

    public static final PrintStream out

  The "standard" output stream. This stream is already open and ready to accept output data. Typically this stream corresponds to display output or another output destination specified by the host environment or user.

  For simple stand-alone Java applications, a typical way to write a line of output data is:

  >          System.out.println(data)

  See the `println` methods in class `PrintStream`.

  See Also:
    `PrintStream.println()`, `PrintStream.println(boolean)`, `PrintStream.println(char)`, `PrintStream.println(char[])`, `PrintStream.println(int)`, `PrintStream.println(long)`, `PrintStream.println(java.lang.Object)`, `PrintStream.println(java.lang.String)`

### err

    public static final PrintStream err

  The "standard" error output stream. This stream is already open and ready to accept output data.

  Typically this stream corresponds to display output or another output destination specified by the host environment or user. By convention, this output stream is used to display error messages or other information that should come to the immediate attention of a user even if the principal output stream, the value of the variable `out`, has been redirected to a file or other destination that is typically not continuously monitored.

Method Detail

### currentTimeMillis

    public static long currentTimeMillis()

  Returns the current time in milliseconds.
  Returns:
    the difference, measured in milliseconds, between the current time and midnight, January 1, 1970 UTC.

### arraycopy

    public static void arraycopy(Object src,
                                 int src_position,
                                 Object dst,
                                 int dst_position,
                                 int length)

  Copies an array from the specified source array, beginning at the specified position, to the specified position of the destination array. A subsequence of array components are copied from the source array referenced by `src` to the destination array referenced by `dst`. The number of components copied is equal to the `length` argument. The components at positions `srcOffset` through `srcOffset+length-1` in the source array are copied into positions `dstOffset` through `dstOffset+length-1`, respectively, of the destination array.

  If the `src` and `dst` arguments refer to the same array object, then the copying is performed as if the components at positions `srcOffset` through `srcOffset+length-1` were first copied to a temporary array with `length` components and then the contents of the temporary array were copied into positions `dstOffset` through `dstOffset+length-1` of the destination array.

  If `dst` is `null`, then a `NullPointerException` is thrown.

  If `src` is `null`, then a `NullPointerException` is thrown and the destination array is not modified.

  Otherwise, if any of the following is true, an `ArrayStoreException` is thrown and the destination is not modified:

  - The `src` argument refers to an object that is not an array.
  - The `dst` argument refers to an object that is not an array.
  - The `src` argument and `dst` argument refer to arrays whose component types are different primitive types.
  - The `src` argument refers to an array with a primitive component type and the `dst` argument refers to an array with a reference component type.
  - The `src` argument refers to an array with a reference component type and the `dst` argument refers to an array with a primitive component type.

  Otherwise, if any of the following is true, an `IndexOutOfBoundsException` is thrown and the destination is not modified:

  - The `srcOffset` argument is negative.
  - The `dstOffset` argument is negative.
  - The `length` argument is negative.
  - `srcOffset+length` is greater than `src.length`, the length of the source array.
  - `dstOffset+length` is greater than `dst.length`, the length of the destination array.

  Otherwise, if any actual component of the source array from position `srcOffset` through `srcOffset+length-1` cannot be converted to the component type of the destination array by assignment conversion, an `ArrayStoreException` is thrown. In this case, let k be the smallest nonnegative integer less than length such that `src[srcOffset+`k`]` cannot be converted to the component type of the destination array; when the exception is thrown, source array components from positions `srcOffset` through `srcOffset+`k`-1` will already have been copied to destination array positions `dstOffset` through `dstOffset+`k`-1` and no other positions of the destination array will have been modified. (Because of the restrictions already itemized, this paragraph effectively applies only to the situation where both arrays have component types that are reference types.)

  Parameters:
    `src` - the source array.
    `src_position` - start position in the source array.
    `dst` - the destination array.
    `dst_position` - pos start position in the destination data.
    `length` - the number of array elements to be copied.
  Throws:
    IndexOutOfBoundsException - if copying would cause access of data outside array bounds.
    ArrayStoreException - if an element in the `src` array could not be stored into the `dest` array because of a type mismatch.
    NullPointerException - if either `src` or `dst` is `null`.

### identityHashCode

    public static int identityHashCode(Object x)

  Returns the same hashcode for the given object as would be returned by the default method hashCode(), whether or not the given object's class overrides hashCode(). The hashcode for the null reference is zero.
  Parameters:
    `x` - object for which the hashCode is to be calculated
  Returns:
    the hashCode
  Since:
    JDK1.1

### getProperty

    public static String getProperty(String key)

  Gets the system property indicated by the specified key.
  Parameters:
    `key` - the name of the system property.
  Returns:
    the string value of the system property, or `null` if there is no property with that key.
  Throws:
    NullPointerException - if `key` is `null`.
    IllegalArgumentException - if `key` is empty.

### exit

    public static void exit(int status)

  Terminates the currently running Java application. The argument serves as a status code; by convention, a nonzero status code indicates abnormal termination.

  This method calls the `exit` method in class `Runtime`. This method never returns normally.

  The call `System.exit(n)` is effectively equivalent to the call:

  >      Runtime.getRuntime().exit(n)

  Parameters:
    `status` - exit status.
  See Also:
    `Runtime.exit(int)`

### gc

    public static void gc()

  Runs the garbage collector.

  Calling the `gc` method suggests that the Java Virtual Machine expend effort toward recycling unused objects in order to make the memory they currently occupy available for quick reuse. When control returns from the method call, the Java Virtual Machine has made a best effort to reclaim space from all discarded objects.

  The call `System.gc()` is effectively equivalent to the call:

  >      Runtime.getRuntime().gc()

  See Also:
    `Runtime.gc()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| MID Profile
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a comment or suggestion Version 0.95 of MID Profile Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries. Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,Palo Alto, California, 94303, U.S.A. All Rights Reserved.